#include <stdio.h>
#include <math.h>
#include <algorithm>
using namespace std;

const int MaxN = 502;
const int osn = 9;
const int MaxK = 1500 / osn + 2;
typedef int TLong[MaxK];
bool walls[MaxN][MaxN];
TLong cnt[2][MaxN];
int i, j, n, m, MaxQ, tmp, p, p_1;
char c;
FILE *fi, *fo;

void LongAddition(TLong &c, TLong &a, TLong &b){
  //c = a + b;
  int i;
  memset(c, 0, sizeof(TLong));
  c[0] = max(a[0], b[0]);
  for(i = 1; i <= c[0]; ++i){
    c[i] = a[i] + b[i];
  }
  for(i = 1; i <= c[0]; ++i){
    if(c[i] >= MaxQ){
      ++c[i+1];
      c[i] -= MaxQ;
    }
  }
  if(c[c[0]+1] != 0) ++c[0];
}

void PrintLong(TLong &a){
  fprintf(fo, "%i", a[a[0]--]);
  for(int i = a[0]; i >= 1; --i){
    fprintf(fo, "%0.*i", osn, a[i]);
  }
}

int main(){
  MaxQ = (int)pow(10.0, osn);
  fi = fopen("input.txt", "r") ;
  fo = fopen("output.txt", "w") ;
  fscanf(fi, "%i%i\n", &n, &m);
  for(i = 0; i <= n+1; ++i){
    walls[i][0] = walls[i][m+1] = true;
  }
  for(j = 0; j <= m+1; ++j){
    walls[0][j] = walls[n+1][j] = true;
  }
  for(i = n; i >= 1; --i){
    for(j = 1; j <= m; ++j){
      fscanf(fi, "%c", &c);
      walls[i][j] = (c == '#');
    }
    fscanf(fi, "\n");
  }
 for(j = 1; !walls[1][j]; ++j){
    cnt[1][j][0] = cnt[1][j][1] = 1;
  }     
  for(i = 2; i <= n; ++i){
    for(j = 1; j <= m+1; ++j){
      p = i & 1; p_1 = 1-p;
      if(walls[i][j]){
        memset(cnt[p][j], 0, sizeof(TLong));
        if(j == 1) continue;
        for(tmp = j-1; !walls[i][tmp]; --tmp){
          memcpy(cnt[p][tmp], cnt[p][j-1], sizeof(int)*(cnt[p][j-1][0]+1));
        }                                                           
      }else{
        LongAddition(cnt[p][j], cnt[p_1][j], cnt[p][j-1]);
      }
    }
  }
  PrintLong(cnt[n & 1][m]);
  fclose(fi);
  fclose(fo);
  return 0;
}